/*
 * BullCow.java
 *
 * Created on 10.02.2004
 * (c) Arcanum
 * http://faqsite.narod.ru 
 */

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import java.util.*;

public class BullCow extends MIDlet implements CommandListener {
    private String sPuzzle;
    private int iMaxPuzzleNum   = 4;
    private int iMove           = 0;
// helper functions
    private boolean isCorrectMove(String sMove)
    {
        if(sMove.length() != iMaxPuzzleNum)
            return false;
        for(int i = 0; i < sMove.length(); i++)
        {
            if(sMove.indexOf(sMove.charAt(i)) != i)
                return false;
        }
        return true;
    }
//Just shuffle an array of digits    
    private void makePuzzle()
    {
        char pszSource[] = {'0','1','2','3','4','5','6','7','8','9'};
        // Shuffle pszSource
        for(int i = 0; i < 100; i++)
        {
            Random rnd = new Random(System.currentTimeMillis());
            int iSrc = Math.abs(rnd.nextInt()) % 10;
/*
 * For the bug in the emulator we should uncomment this
            try
            {
                Thread.currentThread().sleep(1);
            }
            catch(InterruptedException e) { }
*/      
            int iDst = Math.abs(rnd.nextInt()) % 10;
            
            char tmp = pszSource[iDst];
            pszSource[iDst] = pszSource[iSrc];
            pszSource[iSrc] = tmp;
        }
        sPuzzle = new String(pszSource, 0, iMaxPuzzleNum);
    }
    
    private Command     exitCommand; // The exit command
    private Command     newCommand;  // New game
    private Command     moveCommand; // Make move
    private Command     helpCommand;
    private Command     aboutCommand;
    
    private Display     display;     // The display for this MIDlet
    
    private Form        mainForm;
    
    private TextField   moveTextField;
    public BullCow() {
        display = Display.getDisplay(this);
    // Init commands
        exitCommand     = new Command("Exit", Command.SCREEN, 5);
        aboutCommand    = new Command("About",Command.SCREEN, 4);
        helpCommand     = new Command("Help", Command.SCREEN, 3);
        newCommand      = new Command("Start", Command.SCREEN, 2);
        moveCommand     = new Command("Move", Command.OK, 1);
    }
    
    public void startApp() {
    //Create visible components of the form...
        mainForm            = new Form("Bulls and Cows");
        moveTextField       = new TextField("Move", "", iMaxPuzzleNum, TextField.NUMERIC);        
    // ... and let's add the commands to it
        mainForm.addCommand(exitCommand);
        mainForm.addCommand(newCommand);
        mainForm.addCommand(helpCommand);
        mainForm.addCommand(aboutCommand);        
        mainForm.setCommandListener(this);
	
        display.setCurrent(mainForm);
    }
    
    /**
     * Pause is a no-op since there are no background activities or
     * record stores that need to be closed.
     */
    public void pauseApp() {
    }
    
    /**
     * Destroy must cleanup everything not handled by the garbage collector.
     * In this case there is nothing to cleanup.
     */
    public void destroyApp(boolean unconditional) {
    }
    
    /*
     * Respond to commands, including exit
     * On the exit command, cleanup and notify that the MIDlet has been destroyed.
     */
    public void commandAction(Command c, Displayable s) {
        
        if (c == exitCommand) {
            destroyApp(false);
            notifyDestroyed();
        }
        
        if(c == newCommand)
        {
            makePuzzle();
            // We have to delete the form's elements starting at the end.
            // It provides more faster work.
            for(int i = mainForm.size(); i > 0; i--)
            {
                mainForm.delete(i - 1);
            }
            iMove = 0;

            mainForm.append(moveTextField);
            mainForm.addCommand(moveCommand);                    
       }
        
        if(c == helpCommand)
        {
            Alert helpAlert = new Alert(
            "Help", "The target of this game is to find the guessed number. The number consists of four digits from 0 to 9. For instance: 0915. \nAll digits of the number to be find are different.\n'+' means 'bull' that is a digit on its place, while \n'-' means 'cow' - it's a digit on a wrong place.", 
            null, null);
            helpAlert.setTimeout(Alert.FOREVER);
            display.setCurrent(helpAlert, mainForm);
        }
        
        if(c == aboutCommand)
        {
            Alert helpAlert = new Alert(
            "About", "Arcanum (c) 2004\nfaqsite.narod.ru", 
            null, null);
            helpAlert.setTimeout(Alert.FOREVER);
            display.setCurrent(helpAlert, mainForm);
        }
        
        if(c == moveCommand)
        {
            String sMove = moveTextField.getString();
            if(isCorrectMove(sMove))
            {
		// Let's count vbulls and cows
                int iCow = 0; int iBull = 0;
                for(int i = 0; i < iMaxPuzzleNum; i++)
                {
                    if(sMove.charAt(i) == sPuzzle.charAt(i))
                        iBull++;
                    else
                    {
                        for(int k = 0; k < iMaxPuzzleNum; k++)
                        {
                            if(sMove.charAt(i) == sPuzzle.charAt(k))
                            {
                                iCow++;
                                break;
                            }
                        }
                    }
                }
            
                sMove += ": ";
                for(int i = 0; i < iBull; i++)
                    sMove += "+";
                for(int i = 0; i < iCow; i++)
                    sMove += "-";
                sMove += "\n";
		// now show the move result
                mainForm.append(sMove);
                moveTextField.setString(""); iMove++;
		// Check for the victory                
                if(iBull == iMaxPuzzleNum)
                {
                    mainForm.removeCommand(moveCommand);
                    
                    Alert victoryAlert = new Alert(
                        "Victory", "\n   You guessed it\n" + "    in " + String.valueOf(iMove) + " move(s)",
                        null, AlertType.INFO);
                    victoryAlert.setTimeout(Alert.FOREVER);
                    display.setCurrent(victoryAlert, mainForm);
                }
            }
            else
            {
		//An illegal move
                    Alert wrongAlert = new Alert(
                        "Error", "\n    Illegal move!", null, AlertType.ERROR);
                    wrongAlert.setTimeout(Alert.FOREVER);
                    display.setCurrent(wrongAlert, mainForm);            
            }
        }
    }
}
